# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/04_strs.ipynb.

# %% auto 0
__all__ = ['isallstr', 'isdunder', 'isnilstr']

# %% ../nbs/04_strs.ipynb 4
from typing import Union, Literal, TypeGuard, Iterable

# %% ../nbs/04_strs.ipynb 5
from .core import isiter, isstr

# %% ../nbs/04_strs.ipynb 7
def isallstr(x) -> TypeGuard[Iterable[str]]:
    '''Check if `x` is an `Iterable[str]`.'''
    return isiter(x) and all(isstr(e) for e in x)

# %% ../nbs/04_strs.ipynb 9
def isdunder(s: str) -> TypeGuard[str]:
    '''Check if `s` is an dunder e.g. `'__{anything}__'`.'''
    return isstr(s) and s.startswith('__') and s.endswith('__') and len(s) > 4

def isnilstr(s: str) -> TypeGuard[Literal['']]:
    '''Check if `s` is the nil string `''`.'''
    return isstr(s) and len(s) == 0
